<?php

namespace rdyescapia\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BusinessSrvcPrefType StructType
 * @subpackage Structs
 */
class BusinessSrvcPrefType extends AbstractStructBase
{
    /**
     * The _
     * @var string
     */
    public $_;
    /**
     * The PreferLevel
     * Meta information extracted from the WSDL
     * - default: Preferred
     * @var string
     */
    public $PreferLevel;
    /**
     * The BusinessSrvcType
     * @var string
     */
    public $BusinessSrvcType;
    /**
     * Constructor method for BusinessSrvcPrefType
     * @uses BusinessSrvcPrefType::set_()
     * @uses BusinessSrvcPrefType::setPreferLevel()
     * @uses BusinessSrvcPrefType::setBusinessSrvcType()
     * @param string $_
     * @param string $preferLevel
     * @param string $businessSrvcType
     */
    public function __construct($_ = null, $preferLevel = 'Preferred', $businessSrvcType = null)
    {
        $this
            ->set_($_)
            ->setPreferLevel($preferLevel)
            ->setBusinessSrvcType($businessSrvcType);
    }
    /**
     * Get _ value
     * @return string|null
     */
    public function get_()
    {
        return $this->_;
    }
    /**
     * Set _ value
     * @param string $_
     * @return \rdyescapia\StructType\BusinessSrvcPrefType
     */
    public function set_($_ = null)
    {
        // validation for constraint: string
        if (!is_null($_) && !is_string($_)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($_, true), gettype($_)), __LINE__);
        }
        $this->_ = $_;
        return $this;
    }
    /**
     * Get PreferLevel value
     * @return string|null
     */
    public function getPreferLevel()
    {
        return $this->PreferLevel;
    }
    /**
     * Set PreferLevel value
     * @uses \rdyescapia\EnumType\PreferLevelType::valueIsValid()
     * @uses \rdyescapia\EnumType\PreferLevelType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $preferLevel
     * @return \rdyescapia\StructType\BusinessSrvcPrefType
     */
    public function setPreferLevel($preferLevel = 'Preferred')
    {
        // validation for constraint: enumeration
        if (!\rdyescapia\EnumType\PreferLevelType::valueIsValid($preferLevel)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \rdyescapia\EnumType\PreferLevelType', is_array($preferLevel) ? implode(', ', $preferLevel) : var_export($preferLevel, true), implode(', ', \rdyescapia\EnumType\PreferLevelType::getValidValues())), __LINE__);
        }
        $this->PreferLevel = $preferLevel;
        return $this;
    }
    /**
     * Get BusinessSrvcType value
     * @return string|null
     */
    public function getBusinessSrvcType()
    {
        return $this->BusinessSrvcType;
    }
    /**
     * Set BusinessSrvcType value
     * @param string $businessSrvcType
     * @return \rdyescapia\StructType\BusinessSrvcPrefType
     */
    public function setBusinessSrvcType($businessSrvcType = null)
    {
        // validation for constraint: string
        if (!is_null($businessSrvcType) && !is_string($businessSrvcType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($businessSrvcType, true), gettype($businessSrvcType)), __LINE__);
        }
        $this->BusinessSrvcType = $businessSrvcType;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \rdyescapia\StructType\BusinessSrvcPrefType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
