<?php

namespace rdyescapia\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ResCommonDetailType StructType
 * @subpackage Structs
 */
class ResCommonDetailType extends AbstractStructBase
{
    /**
     * The GuestCounts
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \rdyescapia\StructType\GuestCountType
     */
    public $GuestCounts;
    /**
     * The TimeSpan
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \rdyescapia\StructType\DateTimeSpanType
     */
    public $TimeSpan;
    /**
     * The ResGuestRPHs
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \rdyescapia\ArrayType\ArrayOfResGuestRPHsTypeResGuestRPH
     */
    public $ResGuestRPHs;
    /**
     * The Memberships
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \rdyescapia\ArrayType\ArrayOfMembershipTypeMembership
     */
    public $Memberships;
    /**
     * The Comments
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \rdyescapia\ArrayType\ArrayOfCommentTypeComment
     */
    public $Comments;
    /**
     * The SpecialRequests
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \rdyescapia\ArrayType\ArrayOfSpecialRequestTypeSpecialRequest
     */
    public $SpecialRequests;
    /**
     * The Guarantee
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \rdyescapia\StructType\GuaranteeType
     */
    public $Guarantee;
    /**
     * The DepositPayments
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \rdyescapia\ArrayType\ArrayOfRequiredPaymentsTypeGuaranteePayment
     */
    public $DepositPayments;
    /**
     * The CancelPenalties
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \rdyescapia\StructType\CancelPenaltiesType
     */
    public $CancelPenalties;
    /**
     * The Fees
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \rdyescapia\ArrayType\ArrayOfFeeType
     */
    public $Fees;
    /**
     * The Total
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \rdyescapia\StructType\TotalType
     */
    public $Total;
    /**
     * Constructor method for ResCommonDetailType
     * @uses ResCommonDetailType::setGuestCounts()
     * @uses ResCommonDetailType::setTimeSpan()
     * @uses ResCommonDetailType::setResGuestRPHs()
     * @uses ResCommonDetailType::setMemberships()
     * @uses ResCommonDetailType::setComments()
     * @uses ResCommonDetailType::setSpecialRequests()
     * @uses ResCommonDetailType::setGuarantee()
     * @uses ResCommonDetailType::setDepositPayments()
     * @uses ResCommonDetailType::setCancelPenalties()
     * @uses ResCommonDetailType::setFees()
     * @uses ResCommonDetailType::setTotal()
     * @param \rdyescapia\StructType\GuestCountType $guestCounts
     * @param \rdyescapia\StructType\DateTimeSpanType $timeSpan
     * @param \rdyescapia\ArrayType\ArrayOfResGuestRPHsTypeResGuestRPH $resGuestRPHs
     * @param \rdyescapia\ArrayType\ArrayOfMembershipTypeMembership $memberships
     * @param \rdyescapia\ArrayType\ArrayOfCommentTypeComment $comments
     * @param \rdyescapia\ArrayType\ArrayOfSpecialRequestTypeSpecialRequest $specialRequests
     * @param \rdyescapia\StructType\GuaranteeType $guarantee
     * @param \rdyescapia\ArrayType\ArrayOfRequiredPaymentsTypeGuaranteePayment $depositPayments
     * @param \rdyescapia\StructType\CancelPenaltiesType $cancelPenalties
     * @param \rdyescapia\ArrayType\ArrayOfFeeType $fees
     * @param \rdyescapia\StructType\TotalType $total
     */
    public function __construct(\rdyescapia\StructType\GuestCountType $guestCounts = null, \rdyescapia\StructType\DateTimeSpanType $timeSpan = null, \rdyescapia\ArrayType\ArrayOfResGuestRPHsTypeResGuestRPH $resGuestRPHs = null, \rdyescapia\ArrayType\ArrayOfMembershipTypeMembership $memberships = null, \rdyescapia\ArrayType\ArrayOfCommentTypeComment $comments = null, \rdyescapia\ArrayType\ArrayOfSpecialRequestTypeSpecialRequest $specialRequests = null, \rdyescapia\StructType\GuaranteeType $guarantee = null, \rdyescapia\ArrayType\ArrayOfRequiredPaymentsTypeGuaranteePayment $depositPayments = null, \rdyescapia\StructType\CancelPenaltiesType $cancelPenalties = null, \rdyescapia\ArrayType\ArrayOfFeeType $fees = null, \rdyescapia\StructType\TotalType $total = null)
    {
        $this
            ->setGuestCounts($guestCounts)
            ->setTimeSpan($timeSpan)
            ->setResGuestRPHs($resGuestRPHs)
            ->setMemberships($memberships)
            ->setComments($comments)
            ->setSpecialRequests($specialRequests)
            ->setGuarantee($guarantee)
            ->setDepositPayments($depositPayments)
            ->setCancelPenalties($cancelPenalties)
            ->setFees($fees)
            ->setTotal($total);
    }
    /**
     * Get GuestCounts value
     * @return \rdyescapia\StructType\GuestCountType|null
     */
    public function getGuestCounts()
    {
        return $this->GuestCounts;
    }
    /**
     * Set GuestCounts value
     * @param \rdyescapia\StructType\GuestCountType $guestCounts
     * @return \rdyescapia\StructType\ResCommonDetailType
     */
    public function setGuestCounts(\rdyescapia\StructType\GuestCountType $guestCounts = null)
    {
        $this->GuestCounts = $guestCounts;
        return $this;
    }
    /**
     * Get TimeSpan value
     * @return \rdyescapia\StructType\DateTimeSpanType|null
     */
    public function getTimeSpan()
    {
        return $this->TimeSpan;
    }
    /**
     * Set TimeSpan value
     * @param \rdyescapia\StructType\DateTimeSpanType $timeSpan
     * @return \rdyescapia\StructType\ResCommonDetailType
     */
    public function setTimeSpan(\rdyescapia\StructType\DateTimeSpanType $timeSpan = null)
    {
        $this->TimeSpan = $timeSpan;
        return $this;
    }
    /**
     * Get ResGuestRPHs value
     * @return \rdyescapia\ArrayType\ArrayOfResGuestRPHsTypeResGuestRPH|null
     */
    public function getResGuestRPHs()
    {
        return $this->ResGuestRPHs;
    }
    /**
     * Set ResGuestRPHs value
     * @param \rdyescapia\ArrayType\ArrayOfResGuestRPHsTypeResGuestRPH $resGuestRPHs
     * @return \rdyescapia\StructType\ResCommonDetailType
     */
    public function setResGuestRPHs(\rdyescapia\ArrayType\ArrayOfResGuestRPHsTypeResGuestRPH $resGuestRPHs = null)
    {
        $this->ResGuestRPHs = $resGuestRPHs;
        return $this;
    }
    /**
     * Get Memberships value
     * @return \rdyescapia\ArrayType\ArrayOfMembershipTypeMembership|null
     */
    public function getMemberships()
    {
        return $this->Memberships;
    }
    /**
     * Set Memberships value
     * @param \rdyescapia\ArrayType\ArrayOfMembershipTypeMembership $memberships
     * @return \rdyescapia\StructType\ResCommonDetailType
     */
    public function setMemberships(\rdyescapia\ArrayType\ArrayOfMembershipTypeMembership $memberships = null)
    {
        $this->Memberships = $memberships;
        return $this;
    }
    /**
     * Get Comments value
     * @return \rdyescapia\ArrayType\ArrayOfCommentTypeComment|null
     */
    public function getComments()
    {
        return $this->Comments;
    }
    /**
     * Set Comments value
     * @param \rdyescapia\ArrayType\ArrayOfCommentTypeComment $comments
     * @return \rdyescapia\StructType\ResCommonDetailType
     */
    public function setComments(\rdyescapia\ArrayType\ArrayOfCommentTypeComment $comments = null)
    {
        $this->Comments = $comments;
        return $this;
    }
    /**
     * Get SpecialRequests value
     * @return \rdyescapia\ArrayType\ArrayOfSpecialRequestTypeSpecialRequest|null
     */
    public function getSpecialRequests()
    {
        return $this->SpecialRequests;
    }
    /**
     * Set SpecialRequests value
     * @param \rdyescapia\ArrayType\ArrayOfSpecialRequestTypeSpecialRequest $specialRequests
     * @return \rdyescapia\StructType\ResCommonDetailType
     */
    public function setSpecialRequests(\rdyescapia\ArrayType\ArrayOfSpecialRequestTypeSpecialRequest $specialRequests = null)
    {
        $this->SpecialRequests = $specialRequests;
        return $this;
    }
    /**
     * Get Guarantee value
     * @return \rdyescapia\StructType\GuaranteeType|null
     */
    public function getGuarantee()
    {
        return $this->Guarantee;
    }
    /**
     * Set Guarantee value
     * @param \rdyescapia\StructType\GuaranteeType $guarantee
     * @return \rdyescapia\StructType\ResCommonDetailType
     */
    public function setGuarantee(\rdyescapia\StructType\GuaranteeType $guarantee = null)
    {
        $this->Guarantee = $guarantee;
        return $this;
    }
    /**
     * Get DepositPayments value
     * @return \rdyescapia\ArrayType\ArrayOfRequiredPaymentsTypeGuaranteePayment|null
     */
    public function getDepositPayments()
    {
        return $this->DepositPayments;
    }
    /**
     * Set DepositPayments value
     * @param \rdyescapia\ArrayType\ArrayOfRequiredPaymentsTypeGuaranteePayment $depositPayments
     * @return \rdyescapia\StructType\ResCommonDetailType
     */
    public function setDepositPayments(\rdyescapia\ArrayType\ArrayOfRequiredPaymentsTypeGuaranteePayment $depositPayments = null)
    {
        $this->DepositPayments = $depositPayments;
        return $this;
    }
    /**
     * Get CancelPenalties value
     * @return \rdyescapia\StructType\CancelPenaltiesType|null
     */
    public function getCancelPenalties()
    {
        return $this->CancelPenalties;
    }
    /**
     * Set CancelPenalties value
     * @param \rdyescapia\StructType\CancelPenaltiesType $cancelPenalties
     * @return \rdyescapia\StructType\ResCommonDetailType
     */
    public function setCancelPenalties(\rdyescapia\StructType\CancelPenaltiesType $cancelPenalties = null)
    {
        $this->CancelPenalties = $cancelPenalties;
        return $this;
    }
    /**
     * Get Fees value
     * @return \rdyescapia\ArrayType\ArrayOfFeeType|null
     */
    public function getFees()
    {
        return $this->Fees;
    }
    /**
     * Set Fees value
     * @param \rdyescapia\ArrayType\ArrayOfFeeType $fees
     * @return \rdyescapia\StructType\ResCommonDetailType
     */
    public function setFees(\rdyescapia\ArrayType\ArrayOfFeeType $fees = null)
    {
        $this->Fees = $fees;
        return $this;
    }
    /**
     * Get Total value
     * @return \rdyescapia\StructType\TotalType|null
     */
    public function getTotal()
    {
        return $this->Total;
    }
    /**
     * Set Total value
     * @param \rdyescapia\StructType\TotalType $total
     * @return \rdyescapia\StructType\ResCommonDetailType
     */
    public function setTotal(\rdyescapia\StructType\TotalType $total = null)
    {
        $this->Total = $total;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \rdyescapia\StructType\ResCommonDetailType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
